#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		majver		%(echo %{version} | cut -d '.' -f1,2)
%define		dmon		ldap
#-----------------------------------------------------------------------------
Name		:	openldap
Version		:	2.6.3
Release		:	14.4.0.0%{?dist}
Summary		:	The OpenLDAP package provides an open source implementation of the Lightweight Directory Access Protocol.
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	OpenLDAP
URL		:	http://www.openldap.org/

Source0		:	%{name}-%{version}.tgz
Patch0		:	%{name}-%{version}-consolidated-1.patch

#-----------------------------------------------------------------------------
BuildRequires	:	cyrus-sasl
BuildRequires	:	openssl-devel

Requires	:	cyrus-sasl
#-----------------------------------------------------------------------------
%description
LDAP stands for Lightweight Directory Access Protocol. As the name
suggests, it is a lightweight protocol for accessing directory services,
specifically X.500-based directory services. LDAP runs over TCP/IP or
other connection oriented transfer services. LDAP is an IETF Standard
Track protocol and is specified in "Lightweight Directory Access
Protocol (LDAP) Technical Specification Road Map" RFC4510.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_sysconfdir}/%{name}/ldap.conf*
%{_libdir}/liblber.so.2*
%{_libdir}/libldap.so.2*
%{_libexecdir}/%{name}/*.so*
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/ldif.5.gz
%{_mandir}/man5/ldap.conf.5.gz

#=============================================================================
%package		devel
Summary		:	LDAP development libraries and header files

Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description devel
The openldap-devel package includes the development libraries and
header files needed for compiling applications that use LDAP
(Lightweight Directory Access Protocol) internals. LDAP is a set of
protocols for enabling directory services over the Internet. Install
this package only if you plan to develop or will need to compile
customized LDAP clients.
files devel

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/openldap.h
%{_includedir}/ldap*.h
%{_includedir}/lber*.h
%{_includedir}/ldif.h
%{_includedir}/slapi-plugin.h
%{_libdir}/liblber.so
%{_libdir}/libldap.so
%{_libdir}/pkgconfig/lber.pc
%{_libdir}/pkgconfig/ldap.pc
%{_mandir}/man3/*.3.gz

#=============================================================================
%package		server
Summary		:	LDAP server

Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		server
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. This package contains the slapd server and related files.

#-----------------------------------------------------------------------------
%files			server
%doc README
%license LICENSE COPYRIGHT
%defattr(-,root,root,-)
%config(noreplace) %dir %attr(0750,%{dmon},%{dmon}) %{_sysconfdir}/%{name}/slapd.d
%config(noreplace) %{_sysconfdir}/%{name}/schema
%config(noreplace) %{_sysconfdir}/%{name}/slapd.conf
%config(noreplace) %{_sysconfdir}/%{name}/slapd.ldif
%{_sysconfdir}/%{name}/slapd.*.default
%{_sbindir}/sl*
%dir %attr(0700,%{dmon},%{dmon}) %{_sharedstatedir}/%{dmon}
%{_mandir}/man5/slapd*.5.gz
%{_mandir}/man5/slapo-*.5.gz
%{_mandir}/man5/slappw-argon2.5.gz
%{_mandir}/man5/lloadd.conf.5.gz
%{_mandir}/man8/lloadd.8.gz
%{_mandir}/man8/sl*.8.gz

#-----------------------------------------------------------------------------
%pre server
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{dmon}

  /usr/sbin/useradd 				\
	-r					\
	-c "Openldap Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{dmon}				\
	-s /sbin/nologin			\
	-d %{_sharedstatedir}/%{dmon}		\
	%{dmon}
  fi

#after upgrade or remove
%preun server
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{dmon} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{dmon}
  /usr/sbin/userdel %{dmon}
  /usr/sbin/groupdel %{dmon}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post server
/sbin/chkconfig --add %{dmon}
%{_sysconfdir}/rc.d/init.d/%{dmon} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		clients
Summary		:	LDAP client utilities

Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		clients
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. The openldap-clients package contains the client
programs needed for accessing and modifying OpenLDAP directories.

#-----------------------------------------------------------------------------
%files			clients
%defattr(-,root,root,-)
%{_bindir}/lda*

#=============================================================================
%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

#-----------------------------------------------------------------------------
#building application
%build
autoconf
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--disable-static				\
	--enable-shared					\
	--enable-debug					\
	--with-tls=openssl				\
	--with-threads					\
	--with-cyrus-sasl				\
	--enable-dynamic				\
	--enable-crypt					\
	--enable-cleartext				\
	--enable-spasswd				\
	--enable-slapd					\
	--enable-modules				\
	--enable-rlookup				\
	--enable-backend=mod				\
	--enable-ipv6					\
	--disable-ndb					\
	--disable-sql					\
	--disable-shell					\
	--disable-bdb					\
	--disable-hdb					\
	--enable-overlays=mod				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} depend
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

install -m 0700 -d 					\
	%{buildroot}%{_sysconfdir}/%{name}/slapd.d

mkdir -p %{buildroot}%{_sharedstatedir}/%{dmon}

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	%{buildroot}%{_libexecdir}			\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
